SketchUp C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Related Functions
SUGuidePointRef Struct Reference

A guide point that has a position. More...

`#include <SketchUpAPI/model/guide_point.h>`

Inherits SUDrawingElementRef.

## Related Functions
(Note that these are not member functions.)
SUEntityRef | SUGuidePointToEntity (SUGuidePointRef guide_point)
| Converts from an SUGuidePointRef to an SUEntityRef. This is essentially an upcast operation. More...
SUGuidePointRef | SUGuidePointFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUGuidePointRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUGuidePointRef. More...
SUDrawingElementRef | SUGuidePointToDrawingElement (SUGuidePointRef guide_point)
| Converts from an SUGuidePointRef to an SUDrawingElementRef. This is essentially an upcast operation. More...
SUGuidePointRef | SUGuidePointFromDrawingElement (SUDrawingElementRef drawing_elem)
| Converts from an SUDrawingElementRef to an SUGuidePointRef. This is essentially a downcast operation so the given element must be convertible to an SUGuidePointRef. More...
enum SUResult | SUGuidePointCreate (SUGuidePointRef *guide_point, const struct SUPoint3D *position)
| Creates a guide point object. The guide point object must be subsequently deallocated with SUGuidePointRelease() unless it is associated with a parent object. More...
enum SUResult | SUGuidePointRelease (SUGuidePointRef *guide_point)
| Releases a guide point object. The guide point object must have been created with SUGuidePointCreate() and not subsequently associated with a parent object (e.g. SUEntitiesAddGuidePoints()). More...
enum SUResult | SUGuidePointGetPosition (SUGuidePointRef guide_point, struct SUPoint3D *position)
| Retrieves the position of a guide point object. More...
enum SUResult | SUGuidePointGetFromPosition (SUGuidePointRef guide_point, struct SUPoint3D *position)
| Retrieves the anchor position of a guide point object. If the point was created in SketchUp then the anchor is the position that was first clicked during the point creation. If the point was created with SUGuidePointCreate the anchor is the origin. More...
enum SUResult | SUGuidePointGetDisplayAsLine (SUGuidePointRef guide_point, bool *as_line)
| Retrieves the boolean indicating if the point should be displayed as a line. More...
Related Functions inherited from SUDrawingElementRef
SUEntityRef | SUDrawingElementToEntity (SUDrawingElementRef elem)
| Converts from an SUDrawingElementRef to an SUEntityRef. This is essentially an upcast operation. More...
SUDrawingElementRef | SUDrawingElementFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUDrawingElementRef. This is essentially a downcast operation so the given entity must be convertible to a drawing element. More...
enum SURefType | SUDrawingElementGetType (SUDrawingElementRef elem)
| Returns the concrete type of the given drawing element. More...
enum SUResult | SUDrawingElementGetBoundingBox (SUDrawingElementRef elem, struct SUBoundingBox3D *bbox)
| Retrieves the bounding box of a drawing element. More...
enum SUResult | SUDrawingElementGetMaterial (SUDrawingElementRef elem, SUMaterialRef *material)
| Retrieves the material object of a drawing element. More...
enum SUResult | SUDrawingElementSetMaterial (SUDrawingElementRef elem, SUMaterialRef material)
| Sets the material of a drawing element. More...
enum SUResult | SUDrawingElementGetLayer (SUDrawingElementRef elem, SULayerRef *layer)
| Retrieves the layer object associated with a drawing element. More...
enum SUResult | SUDrawingElementSetLayer (SUDrawingElementRef elem, SULayerRef layer)
| Sets the layer object to be associated with a drawing element. More...
enum SUResult | SUDrawingElementSetHidden (SUDrawingElementRef elem, bool hide_flag)
| Sets the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementGetHidden (SUDrawingElementRef elem, bool *hide_flag)
| Retrieves the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementSetCastsShadows (SUDrawingElementRef elem, bool casts_shadows_flag)
| Sets the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetCastsShadows (SUDrawingElementRef elem, bool *casts_shadows_flag)
| Retrieves the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementSetReceivesShadows (SUDrawingElementRef elem, bool receives_shadows_flag)
| Sets the receives shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetReceivesShadows (SUDrawingElementRef elem, bool *receives_shadows_flag)
| Retrieves the receives shadows flag of a drawing element. More...
Related Functions inherited from SUEntityRef
enum SURefType | SUEntityGetType (SUEntityRef entity)
| Returns the concrete type of the given entity. More...
enum SUResult | SUEntityGetID (SUEntityRef entity, int32_t *entity_id)
| Retrieves the id of the entity. More...
enum SUResult | SUEntityGetPersistentID (SUEntityRef entity, int64_t *entity_pid)
| Retrieves the persistent id of the entity. More...
enum SUResult | SUEntityGetNumAttributeDictionaries (SUEntityRef entity, size_t *count)
| Retrieves the number of attribute dictionaries of an entity. More...
enum SUResult | SUEntityGetAttributeDictionaries (SUEntityRef entity, size_t len, SUAttributeDictionaryRef dictionaries[], size_t *count)
| Retrieves the attribute dictionaries of an entity. More...
enum SUResult | SUEntityAddAttributeDictionary (SUEntityRef entity, SUAttributeDictionaryRef dictionary)
| Adds the attribute dictionary to an entity. The given dictionary object must not belong to another entity. In other words, each dictionary should be added to one entity only. More...
enum SUResult | SUEntityGetAttributeDictionary (SUEntityRef entity, const char *name, SUAttributeDictionaryRef *dictionary)
| Retrieves the attribute dictionary of an entity that has the given name. More...
enum SUResult | SUEntityGetModel (SUEntityRef entity, SUModelRef *model)
| Retrieves the model object associated with the entity. More...
enum SUResult | SUEntityGetParentEntities (SUEntityRef entity, SUEntitiesRef *entities)
| Retrieves the entities object which contains the entity. More...

## Detailed Description

A guide point that has a position.

Since
  SketchUp 2014 M1, API 2.1

## Friends And Related Function Documentation

enum SUResult SUGuidePointCreate | ( | SUGuidePointRef * | guide_point,
|  | const struct SUPoint3D * | position
| ) |  |
| related

Creates a guide point object. The guide point object must be subsequently deallocated with SUGuidePointRelease() unless it is associated with a parent object.

Since
  SketchUp 2014 M1, API 2.1

Parameters

  [in] | guide_point | The guide point object.
  [out] | position | The guide point position.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_NULL_POINTER_INPUT if guide_point is NULL
  - SU_ERROR_OVERWRITE_VALID if guide_point references a valid object
  - SU_ERROR_NULL_POINTER_INPUT if position is NULL

SUGuidePointRef SUGuidePointFromDrawingElement | ( | SUDrawingElementRef | drawing_elem | ) |
| related

Converts from an SUDrawingElementRef to an SUGuidePointRef. This is essentially a downcast operation so the given element must be convertible to an SUGuidePointRef.

Since
  SketchUp 2015 M0, API 3.0

Parameters

  [in] | drawing_elem | The given element reference.

Returns
  - The converted SUGuidePointRef if the downcast operation succeeds
  - If not, the returned reference will be invalid

SUGuidePointRef SUGuidePointFromEntity | ( | SUEntityRef | entity | ) |
| related

Converts from an SUEntityRef to an SUGuidePointRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUGuidePointRef.

Since
  SketchUp 2014 M1, API 2.1

Parameters

  [in] | entity | The entity object.

Returns
  - The converted SUGuidePointRef if the downcast operation succeeds
  - If the downcast operation fails, the returned reference will be invalid

enum SUResult SUGuidePointGetDisplayAsLine | ( | SUGuidePointRef | guide_point,
|  | bool * | as_line
| ) |  |
| related

Retrieves the boolean indicating if the point should be displayed as a line.

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | guide_point | The guide point object.
  [out] | as_line | Return true if the point is set to be displayed as a line.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if guide point is an invalid object
  - SU_ERROR_NULL_POINTER_OUTPUT if as_line is NULL

enum SUResult SUGuidePointGetFromPosition | ( | SUGuidePointRef | guide_point,
|  | struct SUPoint3D * | position
| ) |  |
| related

Retrieves the anchor position of a guide point object. If the point was created in SketchUp then the anchor is the position that was first clicked during the point creation. If the point was created with SUGuidePointCreate the anchor is the origin.

Since
  SketchUp 2016, API 4.0

Parameters

  [in] | guide_point | The guide point object.
  [out] | position | The guide point anchor position.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if guide point is an invalid object
  - SU_ERROR_NULL_POINTER_OUTPUT if position is NULL

enum SUResult SUGuidePointGetPosition | ( | SUGuidePointRef | guide_point,
|  | struct SUPoint3D * | position
| ) |  |
| related

Retrieves the position of a guide point object.

Since
  SketchUp 2014 M1, API 2.1

Parameters

  [in] | guide_point | The guide point object.
  [out] | position | The guide point position.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if guide point is an invalid object
  - SU_ERROR_NULL_POINTER_OUTPUT if position is NULL

enum SUResult SUGuidePointRelease | ( | SUGuidePointRef * | guide_point | ) |
| related

Releases a guide point object. The guide point object must have been created with SUGuidePointCreate() and not subsequently associated with a parent object (e.g. SUEntitiesAddGuidePoints()).

Since
  SketchUp 2014 M1, API 2.1

Parameters

  [in] | guide_point | The guide point object.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_NULL_POINTER_INPUT if guide_point is NULL
  - SU_ERROR_INVALID_INPUT if guide_point does not reference a valid object

SUDrawingElementRef SUGuidePointToDrawingElement | ( | SUGuidePointRef | guide_point | ) |
| related

Converts from an SUGuidePointRef to an SUDrawingElementRef. This is essentially an upcast operation.

Since
  SketchUp 2015 M0, API 3.0

Parameters

  [in] | guide_point | The given guide point reference.

Returns
  - The converted SUEntityRef if guide_point is a valid guide point.
  - If not, the returned reference will be invalid.

SUEntityRef SUGuidePointToEntity | ( | SUGuidePointRef | guide_point | ) |
| related

Converts from an SUGuidePointRef to an SUEntityRef. This is essentially an upcast operation.

Since
  SketchUp 2014 M1, API 2.1

Parameters

  [in] | guide_point | The guide point object.

Returns
  - The converted SUEntityRef if guide_point is a valid object
  - If not, the returned reference will be invalid

The documentation for this struct was generated from the following files:

- SketchUpAPI/model/defs.h
- SketchUpAPI/model/guide_point.h